org.apache.solr.search.grouping.distributed.shardresultserializer

## Class TopGroupsResultTransformer

- java.lang.Object
- - org.apache.solr.search.grouping.distributed.shardresultserializer.TopGroupsResultTransformer

- All Implemented Interfaces:
    ShardResultTransformer<List<Command>,Map<String,?>>

      public class TopGroupsResultTransformer
      extends Object
      implements ShardResultTransformer<List<Command>,Map<String,?>>

  Implementation for transforming `TopGroups` and `TopDocs` into a `NamedList` structure and visa versa.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `TopGroupsResultTransformer(ResponseBuilder rb)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected NamedList` | `serializeTopDocs(QueryCommandResult result)`
    `protected NamedList` | `serializeTopGroups(TopGroups<BytesRef> data, SchemaField groupField)`
    `NamedList` | `transform(List<Command> data)` Transforms data to a `NamedList` structure for serialization purposes.
    `Map<String,?>` | `transformToNative(NamedList<NamedList> shardResponse, Sort groupSort, Sort sortWithinGroup, String shard)` Transforms the specified shard response into native structures.
    `protected ScoreDoc[]` | `transformToNativeShardDoc(List<NamedList<Object>> documents, Sort groupSort, String shard, IndexSchema schema)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### TopGroupsResultTransformer

          public TopGroupsResultTransformer(ResponseBuilder rb)

  - ### Method Detail

    - #### transform

          public NamedList transform(List<Command> data)
                              throws IOException

      Transforms data to a `NamedList` structure for serialization purposes.
      Specified by:
        `transform` in interface `ShardResultTransformer<List<Command>,Map<String,?>>`
      Parameters:
        `data` - The data to be transformed
      Returns:
        `NamedList` structure
      Throws:
        `IOException` - If I/O related errors occur during transforming

    - #### transformToNative

          public Map<String,?> transformToNative(NamedList<NamedList> shardResponse,
                                                 Sort groupSort,
                                                 Sort sortWithinGroup,
                                                 String shard)

      Transforms the specified shard response into native structures.
      Specified by:
        `transformToNative` in interface `ShardResultTransformer<List<Command>,Map<String,?>>`
      Parameters:
        `shardResponse` - The shard response containing data in a `NamedList` structure
        `groupSort` - The group sort
        `sortWithinGroup` - The sort inside a group
        `shard` - The shard address where the response originated from
      Returns:
        native structure of the data

    - #### transformToNativeShardDoc

          protected ScoreDoc[] transformToNativeShardDoc(List<NamedList<Object>> documents,
                                                         Sort groupSort,
                                                         String shard,
                                                         IndexSchema schema)

    - #### serializeTopGroups

          protected NamedList serializeTopGroups(TopGroups<BytesRef> data,
                                                 SchemaField groupField)
                                          throws IOException

      Throws:
        `IOException`

    - #### serializeTopDocs

          protected NamedList serializeTopDocs(QueryCommandResult result)
                                        throws IOException

      Throws:
        `IOException`

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.